#ifndef CHIARGS_H
#define CHIARGS_H

/****************************************************************************
** COPYRIGHT (C):    1994 Cay S. Horstmann. All Rights Reserved.
** PROJECT:          ChiLib
** FILE:             chiargs.h
** PURPOSE:          Command line argument parsing
** VERSION           1.0
** PROGRAMMER:       Cay Horstmann (CSH)
** START DATE:       5-1-94 (CSH)
** UPDATE HISTORY:
****************************************************************************/

#line 14 "chiargs.cpp"

#include "chisetup.h"

#line 20 "chiargs.cpp"

#ifndef CHISTRNG_H
#include "chistrng.h"
#endif

#line 27 "chiargs.cpp"


class Chi_Args
/* PURPOSE:    Argument parsing
   REMARKS:    the arg and options functions are not const since in some
               command line parsing situations the parsing order has side
               effects. At this point, the class does not support those
               situations, but we want to be prepared for it.
*/
{
public:
   Chi_Args(int, char**);
   Chi_String prog_name() const;
   Chi_String prog_path() const;
   Chi_String arg(int i = - 1);
   Bool option(char c, Chi_String& x, int i = -1);
   Bool int_option(char c, int& x, int i = -1);
   Bool bool_option(char c, Bool& x, int i = -1);

private:
   int _argc;
   char** _argv;
};


#endif
