#ifndef GRSTREAM_H
#define GRSTREAM_H

/****************************************************************************
** COPYRIGHT (C):    1994 Cay S. Horstmann. All Rights Reserved.
** PROJECT:          Mastering Object-Oriented Design
** FILE:             grstream.h
** PURPOSE:          Stream with output onto a graphics context
** VERSION           1.0
** LANGUAGE:         Borland C++ 3.1
** TARGET:           IBM PC
** PROGRAMMERS:      Cay S. Horstmann (CSH)
** START DATE:       September 14, 1994
** UPDATE HISTORY:
****************************************************************************/

#line 16 "GRSTREAM.cpp"

#include "chisetup.h"

#line 22 "GRSTREAM.cpp"

#ifndef CHIGC_H
#include "chigc.h"
#endif

#line 28 "GRSTREAM.cpp"


class GraphicStreambuf : public streambuf
/* PURPOSE:    a stream buffer that sends its overflow to a graphics context
*/
{
public:
   GraphicStreambuf(Chi_GraphicsContext& gc);
protected:
   virtual int overflow(int c);
private:
   Chi_GraphicsContext& _gc;

   double _xnext;
   double _ynext;
};

/*-------------------------------------------------------------------------*/

class GraphicStream : public ostream
/* PURPOSE:    an output stream that sends characters to a graphics context
*/
{
public:
   GraphicStream(Chi_GraphicsContext&);
private:
   GraphicStreambuf _buffer;
};


#endif
